Gecode::Search::Seq::RBS Class Reference

Engine for restart-based search. More...

`#include <rbs.hh>`

## Public Member Functions

| RBS (Space *s, RestartStop *stop0, Engine *e0, const Search::Statistics &stat, const Options &o, bool best)
| Constructor.
virtual Space * | next (void)
| Return next solution (NULL, if none exists or search has been stopped).
virtual Statistics | statistics (void) const
| Return statistics.
virtual bool | stopped (void) const
| Check whether engine has been stopped.
virtual void | constrain (const Space &b)
| Constrain future solutions to be better than b.
virtual | ~RBS (void)
| Destructor.
Public Member Functions inherited from Gecode::Search::Engine
virtual void | reset (Space *s)
| Reset engine to restart at space s (does nothing).
virtual NoGoods & | nogoods (void)
| Return no-goods (the no-goods are empty).
virtual | ~Engine (void)
| Destructor.

## Protected Attributes

Engine * | e
| The actual engine.
Space * | master
| The master space to restart from.
Space * | last
| The last solution space (possibly NULL).
Cutoff * | co
| The cutoff object.
RestartStop * | stop
| The stop control object.
unsigned long int | sslr
| How many solutions since the last restart.
bool | shared_info
| Whether the slave can share info (AFC) with the master.
bool | complete
| Whether search for the next solution will be complete.
bool | restart
| Whether a restart must be performed when next is called.
bool | best
| Whether the engine performs best solution search.

## Additional Inherited Members

Static Public Member Functions inherited from Gecode::HeapAllocated
static void * | operator new (size_t s)
| Memory management.
static void | operator delete (void *p)
| Free memory allocated from heap.

## Detailed Description

Engine for restart-based search.

Definition at line 72 of file rbs.hh.

## Constructor & Destructor Documentation

## RBS()

Gecode::Search::Seq::RBS::RBS | ( | Space * | s,
|  | RestartStop * | stop0,
|  | Engine * | e0,
|  | const Search::Statistics & | stat,
|  | const Options & | o,
|  | bool | best )

inline

Constructor.

Definition at line 65 of file rbs.hpp.

## ~RBS()

Gecode::Search::Seq::RBS::~RBS | ( | void |  | ) |

virtual

Destructor.

Definition at line 150 of file rbs.cpp.

## Member Function Documentation

## next()

Space * Gecode::Search::Seq::RBS::next | ( | void |  | ) |

virtual

Return next solution (NULL, if none exists or search has been stopped).

Implements Gecode::Search::Engine.

Definition at line 56 of file rbs.cpp.

## statistics()

Search::Statistics Gecode::Search::Seq::RBS::statistics | ( | void |  | ) | const

virtual

Return statistics.

Implements Gecode::Search::Engine.

Definition at line 117 of file rbs.cpp.

## stopped()

bool Gecode::Search::Seq::RBS::stopped | ( | void |  | ) | const

virtual

Check whether engine has been stopped.

Implements Gecode::Search::Engine.

Definition at line 139 of file rbs.cpp.

## constrain()

void Gecode::Search::Seq::RBS::constrain | ( | const Space & | b | ) |

virtual

Constrain future solutions to be better than b.

Reimplemented from Gecode::Search::Engine.

Definition at line 122 of file rbs.cpp.

## Member Data Documentation

## e

Engine* Gecode::Search::Seq::RBS::e

protected

The actual engine.

Definition at line 75 of file rbs.hh.

## master

Space* Gecode::Search::Seq::RBS::master

protected

The master space to restart from.

Definition at line 77 of file rbs.hh.

## last

Space* Gecode::Search::Seq::RBS::last

protected

The last solution space (possibly NULL).

Definition at line 79 of file rbs.hh.

## co

Cutoff* Gecode::Search::Seq::RBS::co

protected

The cutoff object.

Definition at line 81 of file rbs.hh.

## stop

RestartStop* Gecode::Search::Seq::RBS::stop

protected

The stop control object.

Definition at line 83 of file rbs.hh.

## sslr

unsigned long int Gecode::Search::Seq::RBS::sslr

protected

How many solutions since the last restart.

Definition at line 85 of file rbs.hh.

## shared_info

bool Gecode::Search::Seq::RBS::shared_info

protected

Whether the slave can share info (AFC) with the master.

Definition at line 87 of file rbs.hh.

## complete

bool Gecode::Search::Seq::RBS::complete

protected

Whether search for the next solution will be complete.

Definition at line 89 of file rbs.hh.

## restart

bool Gecode::Search::Seq::RBS::restart

protected

Whether a restart must be performed when next is called.

Definition at line 91 of file rbs.hh.

## best

bool Gecode::Search::Seq::RBS::best

protected

Whether the engine performs best solution search.

Definition at line 93 of file rbs.hh.

The documentation for this class was generated from the following files:

- gecode/search/seq/rbs.hh
- gecode/search/seq/rbs.cpp
- gecode/search/seq/rbs.hpp